#pragma required_pointer_size long
#ifndef lint
static const char sccsid[] = "@(#)external_suffix.c	1.1     2/10/94";
#endif
/*
*****************************************************************************
**                                                                          *
**                         COPYRIGHT (c) 1991 BY                            *
**             DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.                *
**                          ALL RIGHTS RESERVED                             *
**                                                                          *
**  THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED  *
**  ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE  *
**  INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER  *
**  COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY  *
**  OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY  *
**  TRANSFERRED.                                                            *
**                                                                          *
**  THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE  *
**  AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT  *
**  CORPORATION.                                                            *
**                                                                          *
**  DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS  *
**  SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.                 *
**                                                                          *
*****************************************************************************
**++
**  PRODUCT:
***
**	DEC C++ Demangler
**
**  FILE:  
**
**      white_space.c
**
**  ABSTRACT:
**
**	Grammar element that parses a white_space.
**
**  ENVIRONMENT:
**
**	User Mode
**
**  AUTHORS:
**
** 	Shell S. Simpson (DECwest Engineering)
**
**  MODIFICATION HISTORY:
**
**      $Id: 
**      $Log: 
**
**--
**/


#ifdef CXX_NT
#include "defs.h"
#include "mn_nm.h"
#include "gram_elm.h"
#include "util.h"
#else
#include "demangle.h"
#include "grammar_elements.h"
#endif

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>

/* language element particular definitions */

int /* recognition status */
_external_suffix(const char* s,	/* IN:  string to be parsed */
            int start,		/* IN:  index of first unparsed character */
            int* end)		/* OUT: index of last parsed character */
{
  /* variables common to all language elements */
  int ci;  /* current index */
  char ch; /* current character */
  
/*
**
** DEC C++ generates special functions with external linkage
** for exceptions.  These functions have the form:
**    <normal mangled name> "__EX__" <series of non-whitespace characters>
** These functions are still followed by white space.  In order
** to make these functions seem normal, I'm going to pretend that
** the __EX__... part is white space too...
**
*/

  if(strncmp(&s[start], "__EX__", 6) == 0) /* exception case */
  {
    ch = s[ci = start+6]; /* initialize ch and ci */
    while( ((ch >= 'a') && (ch <= 'z')) || /* is it a lower case letter */
           ((ch >= '0') && (ch <= '9')) || /* is it a number */
           ((ch >= 'A') && (ch <= 'Z')) || /* is it an upper case letter */
           ( ch == '_') || (ch == '$'))    /* is it an underscore or '$' */
    {
       ch = s[++ci]; /* increment ch and ci */
    }
  }
  else /* normal case */
  {
    *end = start - 1;
    return MLD_NOTHING_RECOGNIZED;
  }

  *end = ci - 1; /* ci is one more than the last digit parsed */
  return MLD_SOMETHING_RECOGNIZED;
}
